//Missing some sounds + never ending shells = easter egg'd it
datablock AudioProfile(SuperRedhawkFireSound)
{
   filename    = "./SuperRedhawkFire.wav";
   description = GunShotRange3d;
   preload = true;
};
datablock ProjectileData(SuperRedhawkProjectile)
{
	directDamage		= 30;
	gravityMod			= 0.0;
	muzzleVelocity		= 50;
	brickExplosionForce	= 10;
	impactImpulse		= 100;
	verticalImpulse		= 125;
	lifetime			= 5000;
	fadeDelay			= 4000;
	particleEmitter		= "ShortVaporTrailEmitter";

	radiusDamage		= 0;
	damageRadius		= 0;
	projectileShapeName	= "add-ons/weapon_gun/bullet.dts";
	directDamageType	= $DamageType::UniversalHeadshot;
	radiusDamageType	= $DamageType::UniversalHeadshot;
	brickExplosionRadius			= 0;
	brickExplosionImpact			= true;
	brickExplosionMaxVolume			= 3;
	brickExplosionMaxVolumeFloating	= 10;
	explosion			= GBImpact2Explosion;
	sound				= BulletWhizzingSound;
	velInheritFactor	= 0;
	armingDelay			= 10;
	bounceElasticity	= 0.5;
	bounceFriction		= 0.1;
	isBallistic			= true;
	hasLight			= false;
	lightRadius			= 3.0;
	lightColor			= "0 0 0";
};
function SuperRedhawkProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	%damageType = $DamageType::Direct;
	if(%this.DirectDamageType)
	{
		%damageType = %this.DirectDamageType;
	}
	%scale = getWord(%obj.getScale(), 2);
	%directDamage = 8*5;
	%damage = %directDamage;
	%sobj = %obj.sourceObject;
	if(%col.getType() & $TypeMasks::PlayerObjectType)
	{
		%directDamage = 300;
		%colscale = getWord(%col.getScale(),2);
		if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale && $BKT::HS)
		{
			%directDamage = 95;
			%damageType = $DamageType::UniversalHeadshot;
		}
		%col.damage(%obj, %pos, %directDamage, %damageType);
	}
	else
	{
		%col.damage(%obj,%pos,%directDamage,%damageType);
	}
}
datablock ItemData(SuperRedhawkItem)
{
	shapeFile	= "./SuperRedhawk.dts";
	iconName	= "./icon_SuperRedhawk";
	image		= SuperRedhawkImage;
	uiName			= "Trusty Pants";
	maxAmmo			= 18;

	category		= "Weapon";
	className		= "Weapon";
	rotate			= false;
	mass			= 1;
	density			= 1.5;
	elasticity		= 0.2;
	friction		= 0.75;
	emap			= true;
	doColorShift	= true;
	colorShiftColor	= "0.8 0.1 0.1 1.000";
	canDrop			= true;
	canReload		= 1;
};
datablock ShapeBaseImageData(SuperRedhawkImage)
{
	shapeFile	= "./SuperRedhawk.dts";
	item		= SuperRedhawkItem;
	projectile	= SuperRedhawkProjectile;
	shellExitDir		= "-0.25 -0.25 -0.1";
	shellVelocity		= 2.0;
	minShotTime		= 300;
	eyeOffset		= "0 0 0";

	emap		= true;
	mountPoint	= 0;
	offset		= "0 0 0";
	rotation	= eulerToMatrix( "0 0 0" );
	correctMuzzleVector	= false;
	className			= "WeaponImage";
	ammo				= "";
	projectileType		= Projectile;
	casing				= gunshell2debris;
	shellExitOffset		= "0 0 0";
	shellExitVariance	= 6.0;		
	melee			= false;
	armReady		= true;
	doColorShift	= true;
	colorShiftColor	= SuperRedhawkItem.colorShiftColor;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.215;
	stateTransitionOnTimeout[0]	= "LoadCheckA";

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateTransitionOnNoAmmo[1]		= "Reload";
	stateTransitionOnTimeout[1]		= "weaponLoop";
	stateTimeoutValue[1]			= 0.05;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "Smoke";
	stateTimeoutValue[2]		= 0.05;
	stateFire[2]				= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]			= "fire";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]				= ATACFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= SuperRedhawkFireSound;

	stateName[3]				= "Smoke";
	stateEmitter[3]				= LightSmokeEmitter;
	stateEmitterTime[3]			= 0.075;
	stateEmitterNode[3]			= "muzzleNode";
	stateAllowImageChange[3]	= false;
	stateTransitionOnTimeout[3]	= "TriggerCheck";
	stateTimeoutValue[3]		= 0.2;

	stateName[4] 				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateAllowImageChange[4]	= false;
	stateTimeoutValue[4]		= 0.05;
	stateTransitionOnTimeout[4]	= "LoadCheckB";

	stateName[5]				= "LoadCheckB";
	stateAllowImageChange[5]	= false;
	stateTransitionOnAmmo[5]	= "Ready";
	stateTransitionOnNoAmmo[5]	= "ReloadWait";

	stateName[6]				= "Reload";
	stateAllowImageChange[6]	= true;
	stateTimeoutValue[6]		= 0.55;
	stateScript[6]				= "OnReload";
	stateTransitionOnTimeout[6]	= "Reloading";
	stateWaitForTimeout[6]		= true;
	
	stateName[7]				= "Reloaded";
	stateAllowImageChange[7]	= false;
	stateTimeoutValue[7]		= 0.35;
	stateScript[7]				= "onReloaded";
	stateTransitionOnTimeout[7]	= "Ready";

	stateName[8]					= "weaponLoop";
	stateTransitionOnTriggerDown[8]	= "LoadCheckA";
	stateTimeoutValue[8]			= 0.0;
	stateTransitionOnTimeout[8]		= "Ready";
	stateAllowImageChange[8]		= True;
	stateScript[8]					= "onWeaponLoop";

	stateName[9]				= "ReloadWait";
	stateAllowImageChange[9]	= false;
	stateTimeoutValue[9]		= 0.2;
	stateTransitionOnTimeout[9]	= "Reload";

	stateName[10]					= "TriggerCheck";
	stateAllowImageChange[10]		= false;
	stateTransitionOnTriggerUp[10]	= "LoadCheckA";

	stateName[11]				= "Reloading";
	stateAllowImageChange[11]	= false;
	stateEjectShell[11]			= true;
	stateTimeoutValue[11]		= 0.02;
	stateScript[11]				= "OnReloading";
	stateTransitionOnTimeout[11]= "shell2";
	stateWaitForTimeout[11]		= true;

	stateName[12]				= "shell2";
	stateAllowImageChange[12]	= false;
	stateEjectShell[12]			= true;
	stateTimeoutValue[12]		= 0.02;
	stateTransitionOnTimeout[12]= "shell3";
	stateWaitForTimeout[12]		= true;
	
	stateName[13]				= "shell3";
	stateAllowImageChange[13]	= false;
	stateEjectShell[13]			= true;
	stateTimeoutValue[13]		= 0.02;
	stateTransitionOnTimeout[13]= "shell4";
	stateWaitForTimeout[13]		= true;
	
	stateName[14]				= "shell4";
	stateAllowImageChange[14]	= false;
	stateEjectShell[14]			= true;
	stateTimeoutValue[14]		= 0.02;
	stateTransitionOnTimeout[14]= "shell5";
	stateWaitForTimeout[14]		= true;

	stateName[15]				= "shell5";
	stateAllowImageChange[15]	= false;
	stateEjectShell[15]			= true;
	stateTimeoutValue[15]		= 0.02;
	stateTransitionOnTimeout[15]= "Shell6";
	stateWaitForTimeout[15]		= true;

	stateName[16]				= "shell6";
	stateAllowImageChange[16]	= false;
	stateEjectShell[16]			= true;
	stateTimeoutValue[16]		= 0.4;
	stateTransitionOnTimeout[16]= "Reloaded";
	stateWaitForTimeout[16]		= true;
};
function SuperRedhawkImage::onMount(%this,%obj,%slot)
{
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);}
}
function SuperRedhawkADSImage::onMount(%this,%obj,%slot)
{
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::CH)
	{
		crossHair.setBitmap("add-ons/weapon_blockombat/empty.png");
	}
}
function SuperRedhawkImage::onFire(%this,%obj,%slot)
{
	SuperRedhawkFire(%this,%obj,%slot);
	%obj.toolAmmo[%obj.currTool]--;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::Recoil)
	{
		%projectile = "ATACRecoilProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
	MissionCleanup.add(%p);
	return %p;
}
function SuperRedhawkImage::onWeaponLoop(%this,%obj,%slot)
{
	if(%obj.heat > 0)
	{
		%obj.heat -= 1;
	}
}
function SuperRedhawkFire(%this,%obj,%slot,%val)
{
	%projectile = SuperRedhawkProjectile;
	if(%obj.heat >= 2)
	{
		%obj.playThread(3, shiftAway);
	}
	if(%obj.isImageMounted(SuperRedhawkImage))
	{
		if(vectorLen(%obj.getVelocity()) < 4)
		{
			%spread = 0.001 + (%obj.heat * 0.00025);
		}
		else
		{
			%spread = 0.0014 + (%obj.heat * 0.00025);
		}
	}
	else if(%obj.isImageMounted(SuperRedhawkADSImage))
	{
		if(vectorLen(%obj.getVelocity()) < 4)
		{
			%spread = 0.0006 + (%obj.heat * 0.00025);
		}
		else
		{
			%spread = 0.0008 + (%obj.heat * 0.00025);
		}
	}
	%obj.maxHeat = 6;
	if(%obj.heat < %obj.maxHeat)
		%obj.heat += 2;
	%shellcount = 1;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	if($BKT::Flash)
	{
		%projectile = "ATACFlashProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function SuperRedhawkImage::onReload(%this,%obj,%slot)
{
	%obj.client.quantity["44PRounds"] += %obj.toolAmmo[%obj.currTool];
	%obj.toolAmmo[%obj.currTool] = 0;%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);}
	if(%obj.client.quantity["44PRounds"] >= 1)
	{
//		serverPlay3D(shellHubOpenSound,%obj.getPosition());
		schedule(100,0,%obj.playThread(2, shiftLeft),%obj);
	}
}
function SuperRedhawkImage::onReloading(%this,%obj,%slot)
{
	%obj.client.quantity["44PRounds"] += %obj.toolAmmo[%obj.currTool];
	%obj.toolAmmo[%obj.currTool] = 0;%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);}
	if(%obj.client.quantity["44PRounds"] >= 1)
	{
		%obj.playThread(2, activate);
//		%obj.schedule(200,0,serverPlay3D(shelldropSound,%obj.getPosition()),%obj);
	}
}
function SuperRedhawkImage::onReloaded(%this,%obj,%slot)
{
	if(%obj.client.quantity["44PRounds"] >= 1)
	{
		if(%obj.client.quantity["44PRounds"] > %this.item.maxAmmo)
		{
			%obj.client.quantity["44PRounds"] -= %this.item.maxAmmo;
			%obj.AmmoSpent[%obj.currTool] = 0;
			%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
			%obj.setImageAmmo(%slot,1);
			%obj.playThread(2, shiftright);
//			serverPlay3D(shellhubcloseSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);} 
		}
		else if(%obj.client.quantity["44PRounds"] <= %this.item.maxAmmo)
		{
			%obj.toolAmmo[%obj.currTool] = %obj.client.quantity["44PRounds"];
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["44PRounds"] = 0;	
			%obj.playThread(2, shiftright);
//			serverPlay3D(shellhubcloseSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);} 
			return;
		}
	}
}
datablock ShapeBaseImageData(SuperRedhawkADSImage)
{
	shapeFile	= "./SuperRedhawk.dts";
	item		= SuperRedhawkItem;
	projectile	= SuperRedhawkProjectile;
	shellExitDir		= "-0.25 -0.25 -0.1";
	shellVelocity		= 2.0;
	minShotTime		= 300;
	eyeOffset		= "0 1.5 -0.75";

	emap		= true;
	mountPoint	= 0;
	offset		= "0 0 0";
	rotation	= eulerToMatrix( "0 0 0" );
	correctMuzzleVector	= false;
	className			= "WeaponImage";
	ammo				= "";
	projectileType		= Projectile;
	casing				= gunshell2debris;
	shellExitOffset		= "0 0 0";
	shellExitVariance	= 6.0;		
	melee			= false;
	armReady		= true;
	doColorShift	= true;
	colorShiftColor	= SuperRedhawkItem.colorShiftColor;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "LoadCheckA";

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateTransitionOnNoAmmo[1]		= "Reload";
	stateTransitionOnTimeout[1]		= "weaponLoop";
	stateTimeoutValue[1]			= 0.05;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "Smoke";
	stateTimeoutValue[2]		= 0.05;
	stateFire[2]				= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]			= "kick";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]				= ATACFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= SuperRedhawkFireSound;

	stateName[3]				= "Smoke";
	stateEmitter[3]				= LightSmokeEmitter;
	stateEmitterTime[3]			= 0.075;
	stateEmitterNode[3]			= "muzzleNode";
	stateAllowImageChange[3]	= false;
	stateTransitionOnTimeout[3]	= "TriggerCheck";
	stateTimeoutValue[3]		= 0.2;

	stateName[4] 				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateAllowImageChange[4]	= false;
	stateTimeoutValue[4]		= 0.05;
	stateTransitionOnTimeout[4]	= "LoadCheckB";

	stateName[5]				= "LoadCheckB";
	stateAllowImageChange[5]	= false;
	stateTransitionOnAmmo[5]	= "Ready";
	stateTransitionOnNoAmmo[5]	= "ReloadWait";

	stateName[6]				= "Reload";
	stateScript[6]				= "OnReload";
	
	stateName[7]				= "Reloaded";

	stateName[8]					= "weaponLoop";
	stateTransitionOnTriggerDown[8]	= "LoadCheckA";
	stateTimeoutValue[8]			= 0.0;
	stateTransitionOnTimeout[8]		= "Ready";
	stateAllowImageChange[8]		= True;
	stateScript[8]					= "onWeaponLoop";

	stateName[9]				= "ReloadWait";
	stateAllowImageChange[9]	= false;
	stateTimeoutValue[9]		= 0.5;
	stateTransitionOnTimeout[9]	= "Reload";

	stateName[10]					= "TriggerCheck";
	stateAllowImageChange[10]		= false;
	stateTransitionOnTriggerUp[10]	= "LoadCheckA";
};
function SuperRedhawkADSImage::onWeaponLoop(%this,%obj,%slot)
{
	if (%obj.heat > 0)
	{
		%obj.heat -= 1;
	}
}
function SuperRedhawkADSImage::onFire(%this,%obj,%slot)
{
	SuperRedhawkFire(%this,%obj,%slot);
	%obj.toolAmmo[%obj.currTool]--;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::Recoil)
	{
		%projectile = "ATACRecoilProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
	MissionCleanup.add(%p);
	return %p;
}
function SuperRedhawkADSImage::onReload(%this,%obj,%slot)
{
	%obj.mountImage(SuperRedhawkImage,0);
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.44 Mag. Revolver  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["44PRounds"]+0 @ "", 4, 2, 3, 4);}
}
package SuperRedhawkSights
{
	function armor::onTrigger(%this,%obj,%triggerNum,%val)
	{
		%client = %obj.client;		
		if(%obj.getMountedImage(0) $= SuperRedhawkImage.getID() && %triggerNum == 4 && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(SuperRedhawkADSImage, 0);
			%client.setControlCameraFov(80);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		else if(%triggerNum == 4 && %obj.getMountedImage(0) $= SuperRedhawkADSImage.getID() && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(SuperRedhawkImage, 0);
			%client.setControlCameraFov(90);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		Parent::onTrigger(%this,%obj,%triggerNum,%val);
	}
	function servercmdDropTool(%client,%slot)
	{
		if(%client.player.getMountedImage(0) $= SuperRedhawkADSImage.getID())
		{
		 	%client.player.unmountImage(0);
			%client.setControlCameraFov(90);
			if($BKT::CH)
			{
				crossHair.setBitmap("base/client/ui/crosshair.png");
			}
		}
		return Parent::servercmdDropTool(%client,%slot);
	}
};
activatePackage(SuperRedhawkSights);
function SuperRedhawkADSImage::onUnMount(%this,%obj,%slot)
{
	%obj.client.setControlCameraFov(90);
	if($BKT::CH)
	{
		crossHair.setBitmap("base/client/ui/crosshair.png");
	}
}